﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System;
using System.IO;
using System.Linq;
using HeuristicLab.PluginInfrastructure;

namespace HeuristicLab.Integration.Irace {
  [Application("Irace Hive Target Runner", "Loads an algorithm file and runs it as a Hive job.")]
  public class HiveTargetRunner : ApplicationBase {
    public override void Run(ICommandLineArgument[] args) {
      var output = args.OfType<SimpleArgument>().Single(x => x.Key == "stdout");
      using (var file = File.CreateText(output.Value)) {
        var arg = args.OfType<SimpleArgument>().SingleOrDefault(x => x.Key == "iraceRun");
        if (arg != null) {
          file.WriteLine(arg.Value);
          file.Flush();
        }
        Environment.Exit(0);
      }
    }
  }
}
